diff --git a/gcc/ada/doc/gnat_rm/implementation_advice.rst b/gcc/ada/doc/gnat_rm/implementation_advice.rst
index f2f34db6835..435cfa412ce 100644
--- a/gcc/ada/doc/gnat_rm/implementation_advice.rst
+++ b/gcc/ada/doc/gnat_rm/implementation_advice.rst
@@ -302,14 +302,15 @@ RM 13.1 (21-24): Representation Clauses
 Followed.  In fact, GNAT goes beyond the recommended level of support
 by allowing nonstatic expressions in some representation clauses even
 without the need to declare constants initialized with the values of
-such expressions.
-For example:
+such expressions. For example:
 
 .. code-block:: ada
 
     X : Integer;
     Y : Float;
-    for Y'Address use X'Address;>>
+    for Y'Address use X'Address;
+
+is accepted directly by GNAT.
 
 
   "An implementation need not support a specification for the ``Size``
@@ -585,12 +586,10 @@ RM 13.5.3(7-8): Bit Ordering
 
   "The recommended level of support for the non-default bit ordering is:
 
-  If ``Word_Size`` = ``Storage_Unit``, then the implementation
-  should support the non-default bit ordering in addition to the default
-  bit ordering."
+  The implementation should support the nondefault bit ordering in addition
+  to the default bit ordering."
 
-Followed.  Word size does not equal storage size in this implementation.
-Thus non-default bit ordering is not supported.
+Followed.
 
 .. index:: Address, as private type
 
diff --git a/gcc/ada/doc/gnat_rm/implementation_defined_characteristics.rst b/gcc/ada/doc/gnat_rm/implementation_defined_characteristics.rst
index 0d3f340f1c7..54bcd0c1732 100644
--- a/gcc/ada/doc/gnat_rm/implementation_defined_characteristics.rst
+++ b/gcc/ada/doc/gnat_rm/implementation_defined_characteristics.rst
@@ -554,9 +554,7 @@ which contains a pointer to the dispatching table.
   "If ``Word_Size`` = ``Storage_Unit``, the default bit
   ordering.  See 13.5.3(5)."
 
-``Word_Size`` (32) is not the same as ``Storage_Unit`` (8) for this
-implementation, so no non-default bit ordering is supported.  The default
-bit ordering corresponds to the natural endianness of the target architecture.
+``Word_Size`` does not equal ``Storage_Unit`` in this implementation.
 
 *
   "The contents of the visible part of package ``System``.  See 13.7(2)."
diff --git a/gcc/ada/gnat_rm.texi b/gcc/ada/gnat_rm.texi
index 0c15ad511fa..553e4174d47 100644
--- a/gcc/ada/gnat_rm.texi
+++ b/gcc/ada/gnat_rm.texi
@@ -14363,21 +14363,24 @@ declared before the entity.”
 Followed.  In fact, GNAT goes beyond the recommended level of support
 by allowing nonstatic expressions in some representation clauses even
 without the need to declare constants initialized with the values of
-such expressions.
-For example:
+such expressions. For example:
 
 @example
-  X : Integer;
-  Y : Float;
-  for Y'Address use X'Address;>>
+X : Integer;
+Y : Float;
+for Y'Address use X'Address;
+@end example
+
+is accepted directly by GNAT.
 
+@quotation
 
-"An implementation need not support a specification for the `@w{`}Size`@w{`}
+“An implementation need not support a specification for the @code{Size}
 for a given composite subtype, nor the size or storage place for an
 object (including a component) of a given composite subtype, unless the
 constraints on the subtype and its composite subcomponents (if any) are
-all static constraints."
-@end example
+all static constraints.”
+@end quotation
 
 Followed.  Size Clauses are not permitted on nonstatic components, as
 described above.
@@ -14747,13 +14750,11 @@ Followed.  There are no such components in GNAT.
 
 “The recommended level of support for the non-default bit ordering is:
 
-If @code{Word_Size} = @code{Storage_Unit}, then the implementation
-should support the non-default bit ordering in addition to the default
-bit ordering.”
+The implementation should support the nondefault bit ordering in addition
+to the default bit ordering.”
 @end quotation
 
-Followed.  Word size does not equal storage size in this implementation.
-Thus non-default bit ordering is not supported.
+Followed.
 
 @geindex Address
 @geindex as private type
@@ -16787,9 +16788,7 @@ which contains a pointer to the dispatching table.
 ordering.  See 13.5.3(5).”
 @end itemize
 
-@code{Word_Size} (32) is not the same as @code{Storage_Unit} (8) for this
-implementation, so no non-default bit ordering is supported.  The default
-bit ordering corresponds to the natural endianness of the target architecture.
+@code{Word_Size} does not equal @code{Storage_Unit} in this implementation.
 
 
 @itemize *
diff --git a/gcc/ada/gnat_ugn.texi b/gcc/ada/gnat_ugn.texi
index bba4f25aa13..db06a771ddd 100644
--- a/gcc/ada/gnat_ugn.texi
+++ b/gcc/ada/gnat_ugn.texi
@@ -29666,8 +29666,8 @@ to permit their use in free software.
 
 @printindex ge
 
-@anchor{gnat_ugn/gnat_utility_programs switches-related-to-project-files}@w{                              }
 @anchor{d1}@w{                              }
+@anchor{gnat_ugn/gnat_utility_programs switches-related-to-project-files}@w{                              }
 
 @c %**end of body
 @bye